typedef struct
{
	devrequest setup;
	unsigned int size;
	unsigned char data[64];
} ctrl_transfer_t;

#define QUICKCAM_MINOR 80
#define QUICKCAM_VERSION 0x0001

#define IOCTL_QUICKCAM_CTRLW           _IOWR('d', 0x30, ctrl_transfer_t*)
#define IOCTL_QUICKCAM_CTRLR           _IOWR('d', 0x31, ctrl_transfer_t*)
#define IOCTL_QUICKCAM_ID              _IOWR('d', 0x32, ctrl_transfer_t*)


#ifdef __KERNEL__

typedef enum { _stopped=0, _started } driver_state_t;

typedef struct
{
	struct semaphore mutex;
	struct usb_device *usbdev;
	wait_queue_head_t wait;
	wait_queue_head_t remove_ok;
	spinlock_t lock;
	volatile atomic_t pending_io;
	driver_state_t state;
	int remove_pending;
	int got_mem;
	int total_buffer_size;
	unsigned int overruns;
	int readptr;
	int opened;
	struct list_head free_buff_list;
	struct list_head rec_buff_list;
} quickcam_t;

typedef struct 
{
	quickcam_t *s;
	urb_t *urb;
	struct list_head buff_list;
} buff_t;

#define _QUICKCAM_IF 0
#define _QUICKCAM_ISOPIPE 0x81
#define _ISOPIPESIZE	32768

#endif // KERNEL
